package org.eclipse.tm.tcf.testservice;

import java.util.HashMap;
import java.util.Map;

public class TestInstruction {
	
	public static final String ADD_INSTRUCTION = "Addition";
	public static final String SUB_INSTRUCTION = "Subtraction";
	public static final String MUL_INSTRUCTION = "Multiplication";
	public static final String DIV_INSTRUCTION = "Division";
	public static final String INT_ERROR_OPERATION = "Internal Error";
	
	public static final String ID_ATTR_KEY = "id";
	public static final String OPERATION_ATTR_KEY = "result";
	public static final String ARG1_ATTR_KEY = "arg1";
	public static final String ARG2_ATTR_KEY = "arg2";
	
	public static int cnt = 0;

	private int id;
	private String operation;
	private int arg1;
	private int arg2;
	
	public TestInstruction( String operation, int arg1, int arg2) {
		super();
		this.arg1 = arg1;
		this.arg2 = arg2;
		this.id = cnt++;
		this.operation = operation;
	}
	
	@SuppressWarnings("unchecked")
	public TestInstruction(Map map){
		Integer id = (Integer) map.get(ID_ATTR_KEY);
		String operation = (String) map.get(OPERATION_ATTR_KEY);
		Integer arg1 = (Integer) map.get(ARG1_ATTR_KEY);
		Integer arg2 = (Integer) map.get(ARG2_ATTR_KEY);
		this.id = id;
		this.operation = operation;
		this.arg1 = arg1;
		this.arg2 = arg2;
	}

	public int getId() {
		return id;
	}

	public String getOperation() {
		return operation;
	}

	public int getArg1() {
		return arg1;
	}

	public int getArg2() {
		return arg2;
	}
	
	@SuppressWarnings("unchecked")
	public Map toMap(){
		Map map = new HashMap();
		map.put(ID_ATTR_KEY, id);
		map.put(OPERATION_ATTR_KEY, operation);
		map.put(ARG1_ATTR_KEY, arg1);
		map.put(ARG2_ATTR_KEY, arg2);
		return map;
	}

	public void setOperation(String operation) {
		this.operation = operation;
	}

	public void setArg1(int arg1) {
		this.arg1 = arg1;
	}

	public void setArg2(int arg2) {
		this.arg2 = arg2;
	}
	
	
	
}
