package org.eclipse.tm.tcf.testservice;

import java.util.HashMap;
import java.util.Map;

public class TestResult {
	
	public static final String ID_ATTR_KEY = "id";
	public static final String RESULT_ATTR_KEY = "result";
	public static final String CHECKED_ATTR_KEY = "check";
	public static final String OK_ATTR_KEY = "ok";
	public static final String REM_ATTR_KEY = "rem";
	
	private int id;
	private int result;
	private boolean checked;
	private boolean ok;
	private String rem;
	
	public TestResult(int id, int result, boolean checked, boolean ok, String rem) {
		super();
		this.id = id;
		this.result = result;
		this.checked = checked;
		this.ok = ok;
		this.rem = rem;
	}
	
	@SuppressWarnings("unchecked")
	public TestResult(Map map){
		Integer id = (Integer) map.get(ID_ATTR_KEY);
		Integer result = (Integer) map.get(RESULT_ATTR_KEY);
		Boolean checked = (Boolean) map.get(CHECKED_ATTR_KEY);
		Boolean ok = (Boolean) map.get(OK_ATTR_KEY);
		String rem = (String) map.get(REM_ATTR_KEY);
		this.id = id;
		this.result = result;
		this.checked = checked;
		this.ok = ok;
		this.rem = rem;
	}

	public int getId() {
		return id;
	}

	public int getResult() {
		return result;
	}
	
	public boolean isChecked(){
		return checked;
	}
	
	public void check(boolean checked){
		this.checked = checked;
	}
	
	public boolean isOk(){
		return ok;
	}
	
	public void ok(boolean ok){
		this.ok = ok;
	}
	
	public String getRem(){
		return rem;
	}
	
	public void setRem(String rem){
		this.rem = rem;
	}
	
	@SuppressWarnings("unchecked")
	public Map toMap(){
		Map map = new HashMap();
		map.put(ID_ATTR_KEY, id);
		map.put(RESULT_ATTR_KEY, result);
		map.put(CHECKED_ATTR_KEY, checked);
		map.put(OK_ATTR_KEY, ok);
		map.put(REM_ATTR_KEY, rem);
		return map;
	}
	

}
