package org.eclipse.tm.tcf.testservice;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.tm.tcf.extender.peer.IPeer;
import org.eclipse.tm.tcf.extender.service.IServiceUtilities;
import org.eclipse.tm.tcf.extender.service.ITaskUtilities;
import org.eclipse.tm.tcf.extender.service.proxy.IServiceProxyInterface;
import org.eclipse.tm.tcf.extender.service.proxy.IServiceProxyManager;
import org.eclipse.tm.tcf.extensions.TCFTCP;

public class TestServiceProxyManager implements IServiceProxyManager {
	
	private IServiceUtilities serviceUtilities;
	private final Map<IPeer, TestServiceProxy> proxies = new HashMap<IPeer, TestServiceProxy>();

	public void createServiceProxy(IPeer peer,
			IServiceProxyInterface serviceInterface) {
		TestServiceProxy proxy = new TestServiceProxy(serviceInterface);
		serviceUtilities.publishServideProxy(peer, proxy);
		proxies.put(peer, proxy);
	}

	public String getType() {
		return TCFTCP.TCP_TYPE;
	}

	public void removeServiceProxy(IPeer peer) {
		serviceUtilities.removeServiceProxy(peer, ITestService.NAME);
		TestServiceProxy proxy = proxies.remove(peer);
		if(proxy != null) proxy.terminate();
	}

	public void setServiceUtilities(IServiceUtilities utilities) {
		serviceUtilities = utilities;
	}

	public void setTaskUtilities(ITaskUtilities utilities) {
		// TODO Auto-generated method stub
	}

}
