package org.eclipse.tm.tcf.extender.peer;

import java.util.Map;

public class Peer implements IPeer {

	private final Map<String, String> attributes;
	private final String type;
	private final String name;
	private final String channelType;
	private final String[] serviceProxyTypes;
	private final String[] serviceProviderTypes;
	private final String[] serviceValueAddTypes;

	public Peer(Map<String, String> attributes, String channelType,
			String name, String[] serviceProviderTypes,
			String[] serviceProxyTypes, String[] serviceValueAddTypes,
			String type) {
		super();
		this.attributes = attributes;
		this.channelType = channelType;
		this.name = name;
		this.serviceProviderTypes = serviceProviderTypes;
		this.serviceProxyTypes = serviceProxyTypes;
		this.serviceValueAddTypes = serviceValueAddTypes;
		this.type = type;
	}

	public synchronized String getName() {
		return name;
	}

	public synchronized String getType() {
		return type;
	}

	public synchronized String getAttribute(String attrName) {
		return attributes.get(attrName);
	}

	public synchronized void setAttribute(String attrName, String attrValue) {
		attributes.put(attrName, attrValue);
	}

	public synchronized String getChannelType() {
		return channelType;
	}

	public synchronized String[] getServiceProxyTypes() {
		return serviceProxyTypes;
	}

	public synchronized String[] getServiceProviderTypes() {
		return serviceProviderTypes;
	}

	public synchronized String[] getServiceValueAdderTypes() {
		return serviceValueAddTypes;
	}

}
