package org.eclipse.tm.tcf.extensions.channel;

import java.io.IOException;

import org.eclipse.tm.tcf.extender.channel.IChannelInterface;
import org.eclipse.tm.tcf.extender.peer.IPeer;
import org.eclipse.tm.tcf.extender.service.ITaskUtilities;

public abstract class StreamChannel extends AbstractTCFChannel {

	public static final int ESC = 3;

	public StreamChannel(IPeer peer, IChannelInterface channelInterface,
			ITaskUtilities taskUtilities) {
		super(peer, channelInterface, taskUtilities);
	}

	public final int read() throws IOException {
		int result = get();
		if (result < 0)
			return END_OF_STREAM;
		if (result != ESC)
			return result;
		result = get();
		switch (result) {
		case 0:
			return ESC;
		case 1:
			return END_OF_MESSAGE;
		case 2:
			return END_OF_STREAM;
		default:
			// TODO manage default
			if (result < 0)
				return END_OF_STREAM;
			return 0;
		}
	}

	public final void write(int n) throws IOException {
		switch (n) {
		case ESC:
			put(ESC);
			put(0);
			break;
		case END_OF_MESSAGE:
			put(ESC);
			put(1);
			break;
		case END_OF_STREAM:
			put(ESC);
			put(2);
			break;
		default:
			// TODO manage default
			put(n);
		}
	}

	public abstract int get() throws IOException;

	public abstract void put(int n) throws IOException;

}
