package org.eclipse.tm.tcf.extensions.channel;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

import org.eclipse.tm.tcf.extender.channel.IChannelInterface;
import org.eclipse.tm.tcf.extender.peer.IPeer;
import org.eclipse.tm.tcf.extender.service.ITaskUtilities;
import org.eclipse.tm.tcf.extensions.TCFTCP;

public class TCPChannel extends StreamChannel {

	// TODO Management of open/close channel

	private final Socket socket;
	private InputStream in;
	private OutputStream out;

	public TCPChannel(IPeer peer, IChannelInterface channelInterface,
			ITaskUtilities taskUtilities) throws Exception {
		super(peer, channelInterface, taskUtilities);
		// TODO implement corresponding peer with TCP informations
		socket = new Socket(peer.getAttribute(TCFTCP.HOST_ATTR), Integer
				.decode(peer.getAttribute(TCFTCP.PORT_ATTR)));
		socket.setTcpNoDelay(true);
		in = new BufferedInputStream(socket.getInputStream());
		out = new BufferedOutputStream(socket.getOutputStream());
		start();
	}

	public TCPChannel(IPeer peer, IChannelInterface channelInterface,
			ITaskUtilities taskUtilities, Socket socket) throws Exception {
		super(peer, channelInterface, taskUtilities);
		// TODO implement corresponding peer with TCP informations
		this.socket = socket;
		in = new BufferedInputStream(socket.getInputStream());
		out = new BufferedOutputStream(socket.getOutputStream());
		start();
	}

	@Override
	public int get() throws IOException {
		return in.read();
	}

	@Override
	public void put(int n) throws IOException {
		out.write(n);
	}

	@Override
	public void flush() throws IOException {
		out.flush();
	}

	@Override
	public void stop() throws Exception {
		super.stop();
		socket.close();
		in.close();
		out.close();

	}

}
