package org.eclipse.tm.tcf.extensions.peer;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.eclipse.tm.tcf.extender.peer.IPeer;
import org.eclipse.tm.tcf.extender.peer.IPeerManager;
import org.eclipse.tm.tcf.extender.peer.Peer;
import org.eclipse.tm.tcf.extender.service.ITaskUtilities;
import org.eclipse.tm.tcf.extensions.TCFTCP;

public class TCPPeerManager implements IPeerManager {

	// private ITaskUtilities utilities = null;
	private final Map<String, IPeer> peers = new HashMap<String, IPeer>();

	public String geType() {
		return TCFTCP.TCP_TYPE;
	}

	public IPeer createPeer(String name, Map<String, String> attributes) {
		IPeer peer;
		if (peers.containsKey(name)) {
			peer = peers.get(name);
			for (Entry<String, String> attr : attributes.entrySet()) {
				peer.setAttribute(attr.getKey(), attr.getValue());
			}
		} else {
			String[] types = { TCFTCP.TCP_TYPE };
			peer = new Peer(attributes, TCFTCP.TCP_TYPE, name, types, types,
					types, TCFTCP.TCP_TYPE);
		}
		return peer;
	}

	public Collection<IPeer> getPeers() {
		return new ArrayList<IPeer>(peers.values());
	}

	public void removePeer(IPeer peer) {
		peers.remove(peer.getName());

	}

	public void setTaskUtilities(ITaskUtilities utilities) {
		// this.utilities = utilities;
	}

}